#!/usr/bin/python
# -*- coding: utf-8 -*-

from django.core.management.base import BaseCommand, CommandError
from catalog.models import Polygon
import json, unicodedata
import math

class Command(BaseCommand):

	def handle(self, *args, **options):
		pList = Polygon.objects.all()

		state_parser = {
			'01': "Aguascalientes",  '02': "Baja California", '03': "Baja California Sur", '04': "Campeche",
			'05': "Coahuila",        '06': "Colima",          '07': "Chiapas",             '08': "Chihuahua",
			'09': "Ciudad de México",'10': "Durango",         '11': "Guanajuato",          '12': "Guerrero",
			'13': "Hidalgo",         '14': "Jalisco",         '15': "México",              '16': "Michoacán",
			'17': "Morelos",         '18': "Nayarit",         '19': "Nuevo León",          '20': "Oaxaca",
			'21': "Puebla",          '22': "Querétaro",       '23': "Quintana Roo",        '24': "San Luis Potosí",
			'25': "Sinaloa",         '26': "Sonora",          '27': "Tabasco",             '28': "Tamaulipas",
			'29': "Tlaxcala",        '30': "Veracruz",        '31': "Yucatán",             '32': "Zacatecas"
		}

		for p in pList:
			j = json.loads(p.json_info)
			j['properties']['ENT_NAME'] = state_parser[j['properties']['CVE_ENT']]
			p.json_info = json.dumps(j, ensure_ascii=True)
			p.save()