/// @file taxiMap.js
/// @author Mario Chirinos Colunga
/// @date 2016-04-15
///
Number.prototype.toRadians = function()
{
	return this * Math.PI / 180;
};
function distance(lng1,lat1,lng2,lat2)
{

	var R = 6371e3; // metres
	var f1 = lat1.toRadians();
	var f2 = lat2.toRadians();
	var df = (lat2-lat1).toRadians();
	var dl = (lng2-lng1).toRadians();

	var a = Math.sin(df/2) * Math.sin(df/2) +
		Math.cos(f1) * Math.cos(f2) *
		Math.sin(dl/2) * Math.sin(dl/2);
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));

	var d = R * c;
	return d;
};
//function serializeForm(form)
//{
//    var field, s = [];
//    if (typeof form == 'object' && form.nodeName == "FORM") {
//        var len = form.elements.length;
//        for (i=0; i<len; i++) {
//            field = form.elements[i];
//            if (field.name && !field.disabled && field.type != 'file' && field.type != 'reset' && field.type != 'submit' && field.type != 'button') {
//                if (field.type == 'select-multiple') {
//                    for (j=form.elements[i].options.length-1; j>=0; j--) {
//                        if(field.options[j].selected)
//                            s[s.length] = encodeURIComponent(field.name) + "=" + encodeURIComponent(field.options[j].value);
//                    }
//                } else if ((field.type != 'checkbox' && field.type != 'radio') || field.checked) {
//                    s[s.length] = encodeURIComponent(field.name) + "=" + encodeURIComponent(field.value);
//                }
//            }
//        }
//    }
//    return s.join('&').replace(/%20/g, '+');
//}
//function submitSearchForm()
//{
//	var form = document.getElementById('searchForm');
//	var data = serializeForm(form);
//	console.log(data);

//	var self = this;
//	var xmlhttp;
//	if (window.XMLHttpRequest)
//	{//IE7+, Firefox, Chrome, Opera, Safari
//	  xmlhttp=new XMLHttpRequest();
//	}
//	else
//	{// code for IE6, IE5
//	  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
//	}
//	xmlhttp.onreadystatechange=function()
//	{
//		if (xmlhttp.readyState==4 && xmlhttp.status==200)
//		{
//			var jsonObj = JSON.parse(xmlhttp.responseText);
//			console.log(jsonObj);
//
//
//		}

//	}
//	xmlhttp.open("GET", "ws/index.php", true);
//	xmlhttp.send();
//}
//------------------------------------------------------------------------------
/**
 * Definitions for the languages.
 * @param  divID div name to insert the map
 * @param  lng Longitude
 * @param  lat Latitude
 * @param  z Zoom
 * @return OpenStreetMapsClass object
 */
function sidtMap(divID, lng, lat, z)
{
	OpenStreetMapsClass.call(this, divID, lng, lat, z);
	var self = this;
	this.features = new ol.Collection();
	this.interaction = new ol.interaction.Draw({features: this.features,type: "Polygon"});

	var style = new ol.style.Style({
		stroke: new ol.style.Stroke({
			color: 'rgba(0,0,100,0.8)',
			width: 2
		}),
		fill: new ol.style.Fill({
			color: 'rgba(0,100,200,0.5)'
		})
	});

	this.map.on("moveend",function(e){self.onMapMove(e)});
	this.map.on("pointerdrag",function(e){self.onDrag(e)});
	this.map.on("pointermove",function(e){self.onMousemove(e)});

};

sidtMap.prototype = Object.create( OpenStreetMapsClass.prototype );
//------------------------------------------------------------------------------

sidtMap.prototype.addInteraction = function()
{
	var self = this;

	this.interaction = new ol.interaction.Draw({
		source:this.vectorLayer.getSource(),
		features: this.features,
		type: "Polygon"
	});

	this.interaction.on("drawend",function(e){
		self.showCoords(e.feature.getGeometry());
	});

	this.interaction.on("drawstart",function(e){
		self.removePolygon();
	});

	this.map.addInteraction(this.interaction);
}
//------------------------------------------------------------------------------
sidtMap.prototype.onMousemove = function(e)
{
//	console.log("onMousemove");

}
//------------------------------------------------------------------------------
sidtMap.prototype.onMapMove = function(e)
{
	var lnglat = ol.proj.transform(this.map.getView().getCenter(), 'EPSG:3857', 'EPSG:4326');
	//console.log("onMapMove");
};
//------------------------------------------------------------------------------
sidtMap.prototype.onDrag = function(e)
{
	//console.log("onDrag");
};
//------------------------------------------------------------------------------
sidtMap.prototype.onMapClick = function(e)
{
	//console.log("onMapClick");
	var lnglat = ol.proj.transform(e.coordinate, 'EPSG:3857', 'EPSG:4326');
;
};

//------------------------------------------------------------------------------
