# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import json
import os
# Create your views here.
from collections import OrderedDict

from django.core.paginator import Paginator
from django.http import HttpResponse, Http404
from django.shortcuts import render, render_to_response

from GeoInt_SIDT.tasks import add
from catalog.models import Purchase
from GeoInt_SIDT.tasks import *

# -------------------------------------------------------------------------------

########### lee archivo de configuración ################
dirname = os.path.dirname(__file__)
configfile = os.path.join(dirname, '../config/config.json')

with open(configfile, 'r') as f:
    config = json.load(f)

USERS_PATH = config['PATHS']['PATH_USERS']


###########################################################


def report_L2ASCL(request, report, purchase_id):

    reporteDir =  report.replace('_sclData','')
    image_path = request.user.email + "/" + purchase_id + "/" + "out/"+reporteDir+"/TCI/thumbnails/"
    print(image_path)
    absolute_path = USERS_PATH + request.user.email + "/" + purchase_id + "/out"
    folders = os.listdir(path=absolute_path)
    json_route= USERS_PATH + request.user.email + "/" + purchase_id + "/"

    for file in os.listdir(path=json_route):
        if file.endswith("_sclData.json") and not file.endswith("merge_out_sclData.json"):
            with open(USERS_PATH + request.user.email + "/" + purchase_id + "/" + file) as f:
                json_data = OrderedDict(json.load(f))
                if len(json_data)==0:
                    if file[:6] in folders:
                        folders.remove(file[:6])

    with open(USERS_PATH + request.user.email + "/" + purchase_id + "/findProducts.json") as p:
        dataProduct = json.load(p)
        startDate = str(dataProduct['startDate'])[:4] +'-'+ str(dataProduct['startDate'])[4:6]+'-'+ str(dataProduct['startDate'])[6:8]
        endDate = str(dataProduct['endDate'])[:4] +'-'+ str(dataProduct['endDate'])[4:6]+'-'+ str(dataProduct['endDate'])[6:8]


    with open(USERS_PATH + request.user.email + "/" + purchase_id + "/" + report + ".json") as f:
        json_data = OrderedDict(json.load(f))
        if len(json_data)==0:
            graphData = ""
            defaultLabel=""
            defaultDataset=""
            folders.remove(reporteDir)

        else:
            graphData = dict()
            graphData['type'] = "line"

            data = dict()
            data['labels'] = [k for k, v in sorted(json_data.items())]
            #		data['click']="chartOnClick"
            data['datasets'] = list()
            labels = set()
            for d in json_data:
                labels |= set(json_data[d].keys())
            labels.remove('date')

            labelNames = [
                "No Data", "Saturated", "Shadows", "Cloud Shadows", "Vegetation",
                "Not-Vegetated", "Whater", "Unclassified", "Cloud Medium Probablilty",
                "Cloud Hight Probablilty", "Thin Cirrus", "Snow"
            ]

            colors = [
                "#383838", "#de3d3d", "#696767", "#98775b", "#44ba5d", "#fff98b",
                "#659acc", "#ababab", "#dddddd", "#d9f9ff", "#99d4d9", "#ff8afa"
            ]

            for l in labels:
                item = dict()
                item['label'] = labelNames[int(l)]

                # item['fill'] = "false"
                if l == "0":
                    item['hidden'] = "true"
                item['data'] = [v[l] * 60 * 60 / 1000000. if (l in v) else 0 for k, v in sorted(json_data.items())]
                item['backgroundColor'] = colors[int(l)]
                data['datasets'].append(item)

            data['datasets'].sort(key=lambda k: max(k['data']))

            graphData['data'] = data
            label  =  graphData['data']['labels'][0]
            defaultLabel = graphData['data']['labels'][0]
            defaultDataset = label[0:4]+"/"+label[4:6]+"/"+label[6:]
        #defaultDataset = graphData['data']['datasets'][0]['label']
        # print(settings.BASE_URL)
        #		graphData['options']['responsive']=True
        #		graphData['options']['maintainAspectRatio']=False
        # print(json.dumps(graphData).encode("utf-8"))

    return render(request, 'L2ASCL_data.html', {"graphData": json.dumps(graphData),"name":"foo", "report_name": "SCL Image Classification Data(Km²)", "startDate": startDate,"endDate": endDate,"clouds": dataProduct['clouds'], "platform": dataProduct['platform'],"productLevel": dataProduct['productLevel'] ,"IMAGE_PATH": image_path, 'dafaultLabel': defaultLabel, 'defaultDataSet': defaultDataset, "folders" : folders,"zone":reporteDir })


    # -------------------------------------------------------------------------------def Reports(request):

def Reports(request):
    progress = 0
    productList = []
    size = 0
    folders=[]
    zip =""
    product_list = Purchase.objects.values('id', 'productList', 'aggreg_date', 'search__clouds', 'search__startDate',
                                           'search__endDate', 'search__process_id__name').filter(
        user_id=request.user.id, purchased=1)
    for producto in product_list:
        log_info = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

        #####################################################
        #                progress bar                       #
        #####################################################
        if os.stat(log_info).st_size == 0:
            progress = 0
        else:
            if 'Linking Products...' in open(log_info).read():
                progress = 20
            if 'Merging Images...' in open(log_info).read():
                progress = 40
            if 'Deleting Images...' in open(log_info).read():
                progress = 50
            if 'Extracting SCL information...' in open(log_info).read():
                progress = 60
            if 'Finalizing...' in open(log_info).read():
                progress = 100
            # item = Purchase.objects.filter(pk=producto['id'])
            # item = Purchase.objects.get(pk=producto['id'])
            # item.progress = progress
            # item.save()

        with open(log_info, 'r') as myfile:
            log = myfile.read().replace('\n', '')

        for p in json.loads(producto['productList']):
            size = size + float(p['info']['size'][:-3])
            if size > 1000:
                size2 = size / 1000
                final_size = str(round(size2, 2)) + " GB"
            else:
                final_size = str(round(size, 2)) + " MB"

        initial_folder = "."
        absolute_path = USERS_PATH + request.user.email + "/" +str(producto['id'])+ "/out"
        if not os.path.exists(absolute_path):
            print("folder out noes not exists")
        else:
            folders = os.listdir(path=absolute_path)
            if len(folders)==0:
                initial_folder="../#"
            else:
                initial_folder = folders.pop(0)+"_sclData"

        zip_path = USERS_PATH + request.user.email + "/" +str(producto['id'])
        #print(zip_path)

        #"../ static / reports / tmpImages / repsat_test_dev / umorales @ centrogeo.edu.mx / "+str(producto['id']) / myzip.zip"

        for file in os.listdir(path=zip_path):
            if file.endswith(".zip"):
                print(file)
                zip = zip_path+"/"+file
                print(zip)
        productList.append({
            "process": producto['search__process_id__name'],
            "purchase_date": producto['aggreg_date'],
            "startDate": producto['search__startDate'],
            "endDate": producto['search__endDate'],
            "clouds": producto['search__clouds'],
            "size": final_size,
            "purchase_id": producto['id'],
            "progress": progress,
            "log_info": log,
            "initial_folder" :initial_folder,
            "zip" : zip,
        })
        size = 0
        final_size = 0
        log_info = ""
        progress = 0
        initial_folder = ""
        zip =""


    return render(request, 'Reports.html', {"productList": productList})


# ------------------------------------------------------------------------
def wsProcessProgress(request):
    if request.is_ajax():
        progress = 0
        productList2 = []
        product_list = Purchase.objects.values('id', 'productList', 'aggreg_date', 'search__clouds',
                                               'search__startDate', 'search__endDate',
                                               'search__process_id__name', 'progress').filter(user_id=request.user.id, purchased=1)
        for producto in product_list:
            log_info = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

            #####################################################
            #                progress bar                       #
            #####################################################
            if os.stat(log_info).st_size == 0:
                progress = 0
            else:
                if 'Linking Products...' in open(log_info).read():
                    progress = 20
                if 'Merging Images...' in open(log_info).read():
                    progress = 40
                if 'Deleting Images...' in open(log_info).read():
                    progress = 50
                if 'Extracting SCL information...' in open(log_info).read():
                    progress = 60
                if 'Finalizing...' in open(log_info).read():
                    progress = 100

            item = Purchase.objects.get(pk=producto['id'])
            item.progress = progress
            item.save()

            productList2.append({
                "purchase_id": producto['id'],
                "progress": progress,
            })

            progress = 0
            log_info = ""

        # productList2 = []
        # product_list = Purchase.objects.values('id', 'progress').filter(user_id=request.user.id, purchased=1)
        # for producto in product_list:
        #     productList2.append({
        #         "purchase_id": producto['id'],
        #         "progress": producto['progress'],
        #     })
        return HttpResponse(json.dumps(productList2))
    else:
        raise Http404


# ------------------------------------------------------------------------
# def tareas():
#     result = add.apply_async((2, 1), countdown=3)
#     result.get()
#     return render_to_response('reports_table.html', {"result": result.get()})
